//+------------------------------------------------------------------+
//|                                                CrossedAlerts.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Coders Guru"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
extern int EMAPeriod = 2;
extern int ma_method=MODE_SMMA;
extern bool Alerts = false;

int upalert=false,downalert=false;
//---- buffers
double CrossUp[];
double CrossDown[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);

//   SetIndexStyle(0,DRAW_LINE);
//   SetIndexBuffer(0,ExtMapBuffer1);
//   SetIndexStyle(1,DRAW_LINE);
//   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

/*bool Crossed (double line1 , double line2 )
{

static string last_direction = "";
string current_dirction = "";

if(line1>line2)current_dirction = "up";
if(line1<=line2)current_dirction = "down";



if(current_dirction != last_direction) 
{
      Alert("PIVOT EMA Cross for "+Symbol()+" on the "+Period()+" minute chart.");
      last_direction = current_dirction;
      return (true);
}
else
{
      return (false);

}
 
} 

*/
int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit, counter;
   double EMAprevious, EMAnow, EMAafter, Pivotprevious, Pivotnow, Pivotafter;
   double Range, AvgRange;
//---- check for possible errors
   if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   
   int pos=Bars-counted_bars;
   
   while(pos>=0)
     {

      counter=pos;
      Range=0;
      AvgRange=0;
      for (counter=pos ;counter<=pos+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }

      Range=AvgRange/10;
      EMAnow = iMA(NULL, 0, EMAPeriod, 0, ma_method, PRICE_CLOSE, pos);
      EMAprevious = iMA(NULL, 0, EMAPeriod, 0, ma_method, PRICE_CLOSE, pos+1);
      EMAafter = iMA(NULL, 0, EMAPeriod, 0, ma_method, PRICE_CLOSE, pos-1);

      Pivotnow = iCustom(NULL,0,"PrevDayAndFloatingPivot_HLC",0,pos) ;
      Pivotprevious = iCustom(NULL,0,"PrevDayAndFloatingPivot_HLC",0,pos+1) ;
      Pivotafter = iCustom(NULL,0,"PrevDayAndFloatingPivot_HLC",0,pos-1) ;
      if ((EMAnow > Pivotnow) && (EMAprevious < Pivotprevious) && (EMAafter > Pivotafter)) {
         CrossUp[pos]= Low[pos]-Range*0.5;
         if(pos<=2 && Alerts && !upalert)
         {
            Alert (Symbol()," ",Period(),"M  EMACross UP ");
            //SendMail("EMA Cross Up on "+Symbol(),"");
            upalert=true;
            downalert=false;
         }
      }
      if ((EMAnow < Pivotnow) && (EMAprevious > Pivotprevious) && (EMAafter < Pivotafter)) {
         CrossDown[pos]= Low[pos]-Range*0.5;
         if(pos<=2 && Alerts && !downalert)
         {
            Alert (Symbol()," ",Period(),"M  EMACross DOWN ");
            //SendMail("EMA Cross Down on "+Symbol(),"");
            downalert=true;
            upalert=false;
         }
      }   
         pos--;
     }
     
//     Print(Crossed (ExtMapBuffer1[0],ExtMapBuffer2[0]));


//----
   return(0);
  }
//+------------------------------------------------------------------+